"use strict";

var _themeToDict = _interopRequireDefault(require("../themeToDict"));
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
describe("themeToDict", function () {
  it("converts entry.types to dictionary", function () {
    var input = {
      plain: {
        color: "red"
      },
      styles: [{
        types: ["1", "2"],
        style: {
          color: "green"
        }
      }, {
        types: ["3"],
        style: {
          color: "blue"
        }
      }, {
        types: ["2"],
        style: {
          color: "orange"
        }
      }]
    };
    var expected = {
      root: {
        color: "red"
      },
      plain: {
        color: "red",
        backgroundColor: null
      },
      1: {
        color: "green"
      },
      2: {
        color: "orange"
      },
      3: {
        color: "blue"
      }
    };
    expect((0, _themeToDict["default"])(input)).toEqual(expected);
    // Check order in which keys were added to implicitly test merge strategy
    expect(Object.keys((0, _themeToDict["default"])(input, "js"))).toEqual(Object.keys(expected));
  });
  it("limits entries by entry.languages", function () {
    var input = {
      plain: {},
      styles: [{
        types: ["test"],
        languages: ["js"],
        style: {
          color: "green"
        }
      }]
    };
    expect((0, _themeToDict["default"])(input, "js").test).toEqual({
      color: "green"
    });
    expect((0, _themeToDict["default"])(input, "ocaml").test).toEqual(undefined);
  });
});